leetcode 402. 移掉 K 位数字

题目如下

数据范围

复制代码
    本题可以利用贪心来做,显然我们的目标是使得结果串尽量小,  当两个字符串长度相等时靠前的字符越小整个串越小。
例如"1243" k = 1删除4就行,因为剩下的串长度为3最小的自然是 "123" 。
从这里我们可以感觉到其实我们是要让结果串呈现一种递增的态势这样可以保证是所有结果串中最小的。
那么我们可以维持一个递增序列,这个序列就用来保存需要作为答案的下标。显然可以用单调栈来获得这样的序列。
!注意:当题目给出的原本就是递增的只要删除后面k个即可例如: "12345" k = 1 删除5就可以得到最优解。

通过代码

cpp 复制代码
class Solution {
public:
    string removeKdigits(string num, int k) {
        string ans = "";
        int n = num.size();
        if(n <= k)return "0";
        unordered_set<int> set;
        stack<int> s;
        for(int i = 0;i < n;i++){
            while(!s.empty() && num[s.top()] > num[i]){
                if(k == 0)break;
                set.insert(s.top());
                s.pop();
                k--;
            }
            s.push(i);
        }
        for(int i = 0;i < k;i++){
             set.insert(s.top());
                s.pop();
        }
        for(int i = 0;i < n;i++){
            if(!set.contains(i)){
                if(num[i] == '0' && ans.size() == 0)continue;
                ans += num[i] ;
            }
        }
        if(ans.size() == 0)return "0";
        return ans;//时间复杂度On 
    }
};
相关推荐
悠仁さん3 小时前
【C++】AVL 树
c++
wuminyu3 小时前
JVM规范学习总结:解释器与JIT编译器如何处理JVM字节码
java·linux·c语言·jvm·c++
小徐不徐说4 小时前
序列化与反序列化:把 C++ 对象可靠地保存下来
开发语言·数据库·c++·php
ZhengEnCi4 小时前
模型训练完整流程:从数据准备到模型上线的 10 个关键步骤(全文可跑)
后端·算法
ragnwang4 小时前
Notes: Python pybind11 import C++ module
开发语言·c++·python
充值内卷5 小时前
我给桌面加了个鱼缸:C++ 写后端,WebView2 里养一座 Three.js 小岛
开发语言·javascript·c++
吞下星星的少年·-·7 小时前
Div.3 CF 1131A题(排序,模拟)
算法·模拟·排序
圣保罗的大教堂8 小时前
leetcode 453. 最小操作次数使数组元素相等 中等
leetcode
aichitang20248 小时前
代数拓扑学与现代前沿视角
考研·算法·数学建模·ai·拓扑学·高考